from sqlalchemy.types import Text, Float
from sqlalchemy.schema import Column
from tropofy.database.tropofy_orm import DataSetMixin
from tropofy.app import AppWithDataSets, Step, StepGroup
from tropofy.widgets import SimpleGrid


class Store(DataSetMixin):
    name = Column(Text)
    latitude = Column(Float)
    longitude = Column(Float)


class MyFirstApp(AppWithDataSets):
    def get_name(self, **kwargs):
        return "My First App"

    def get_gui(self, **kwargs):
        return [StepGroup(name='Stores', steps=[Step(name='Stores', widgets=[SimpleGrid(Store)])])]
